/*
 * QU-PROLOG COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
 * 
 * Copyright 1993 by The University of Queensland, Queensland 4072 Australia
 * 
 * Permission to use, copy and distribute this software 
 * for any non-commercial purpose and without fee is hereby
 * granted, provided that the above copyright notice
 * and this permission notice and warranty
 * disclaimer appear in all copies and in supporting documentation, 
 * and that the name of The University of Queensland not be used in 
 * advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission.
 * 
 * Source code modifications are prohibited except where written agreement 
 * has been given in advance by The University of Queensland.
 * 
 * The University of Queensland disclaims all warranties with regard to this
 * software, including all implied warranties of merchantability and fitness.
 * In no event shall The University of Queensland be liable for any special,
 * indirect or consequential damages or any damages whatsoever resulting from
 * loss of use, data or profits, whether in an action of contract, negligence
 * or other tortious action, arising out of or in connection with the use or
 * performance of this software.
 */

#include <string.h>
#include "built_in.h"
#include "built_in_table.h"

/* return the position in the table of pred/arity */
/* if no entry return -1 */

extern void warning (char *, ...);

int 
built_in_index(char *pred, unsigned int arity)
{
	int count = 0;
	int found = 0;
	while(strcmp(BIPred(count), DUMMY) 
	      &&
	      !found
	      )
		if(!(found = ( !strcmp(BIPred(count), pred)
			       &&
			       arity == BIArity(count)
			     )
		    )
		  )
		    count++;
	if(found) return(BINum(count));
	warning("Unknown escape predicate %s/%d", pred, arity);
	return(NOT_FOUND);
}
