/*
 * QU-PROLOG COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
 * 
 * Copyright 1993 by The University of Queensland, Queensland 4072 Australia
 * 
 * Permission to use, copy and distribute this software 
 * for any non-commercial purpose and without fee is hereby
 * granted, provided that the above copyright notice
 * and this permission notice and warranty
 * disclaimer appear in all copies and in supporting documentation, 
 * and that the name of The University of Queensland not be used in 
 * advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission.
 * 
 * Source code modifications are prohibited except where written agreement 
 * has been given in advance by The University of Queensland.
 * 
 * The University of Queensland disclaims all warranties with regard to this
 * software, including all implied warranties of merchantability and fitness.
 * In no event shall The University of Queensland be liable for any special,
 * indirect or consequential damages or any damages whatsoever resulting from
 * loss of use, data or profits, whether in an action of contract, negligence
 * or other tortious action, arising out of or in connection with the use or
 * performance of this software.
 */

#ifndef	LABELS_H
#define	LABELS_H

#define LABEL_TABLE_SIZE 10

typedef struct LABEL
	{
	char    *name;
	unsigned     pc;
	int     *unresolved;
	int     unres_size;
	int     unres_dim;
	} label;

extern label 	*label_table;


int init_label_table(void);

void reset_label_table(void);

int is_in_label_table(char *name);

int lookup_label_table(char *name, int unres);

int resolve_label(char *name, int pc);

#endif	/* LABELS_H */
