/*
 * QU-PROLOG COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
 * 
 * Copyright 1993 by The University of Queensland, Queensland 4072 Australia
 * 
 * Permission to use, copy and distribute this software 
 * for any non-commercial purpose and without fee is hereby
 * granted, provided that the above copyright notice
 * and this permission notice and warranty
 * disclaimer appear in all copies and in supporting documentation, 
 * and that the name of The University of Queensland not be used in 
 * advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission.
 * 
 * Source code modifications are prohibited except where written agreement 
 * has been given in advance by The University of Queensland.
 * 
 * The University of Queensland disclaims all warranties with regard to this
 * software, including all implied warranties of merchantability and fitness.
 * In no event shall The University of Queensland be liable for any special,
 * indirect or consequential damages or any damages whatsoever resulting from
 * loss of use, data or profits, whether in an action of contract, negligence
 * or other tortious action, arising out of or in connection with the use or
 * performance of this software.
 *
 * Access to escape predicates for call/1
 */

'$query' / 0:
end('$query' / 0):

'put' / 1:
	allocate(0)
	escape('put', 1)
	deallocate
	proceed
end('put' / 1):

'get' / 1:
	allocate(0)
	escape('get', 1)
	deallocate
	proceed
end('get' / 1):

'put0' / 1:
	allocate(0)
	escape('put0', 1)
	deallocate
	proceed
end('put0' / 1):

'get0' / 1:
	allocate(0)
	escape('get0', 1)
	deallocate
	proceed
end('get0' / 1):

'$write_atom' / 1:
	allocate(0)
	escape('$write_atom', 1)
	deallocate
	proceed
end('$write_atom' / 1):

'$write_integer' / 1:
	allocate(0)
	escape('$write_integer', 1)
	deallocate
	proceed
end('$write_integer' / 1):

'$write_var_name' / 1:
	allocate(0)
	escape('$write_var_name', 1)
	deallocate
	proceed
end('$write_var_name' / 1):

'$open' / 3:
	allocate(0)
	escape('$open', 3)
	deallocate
	proceed
end('$open' / 3):

'$close' / 1:
	allocate(0)
	escape('$close', 1)
	deallocate
	proceed
end('$close' / 1):

'$set_input' / 1:
	allocate(0)
	escape('$set_input', 1)
	deallocate
	proceed
end('$set_input' / 1):

'$set_output' / 1:
	allocate(0)
	escape('$set_output', 1)
	deallocate
	proceed
end('$set_output' / 1):

'flush' / 0:
	allocate(0)
	escape('flush', 0)
	deallocate
	proceed
end('flush' / 0):

'$read_term_string' / 1:
	allocate(0)
	escape('$read_term_string', 1)
	deallocate
	proceed
end('$read_term_string' / 1):

'$writec' / 5:
	allocate(0)
	escape('$writec', 5)
	deallocate
	proceed
end('$writec' / 5):

'$writeq' / 2:
	allocate(0)
	escape('$writeq', 2)
	deallocate
	proceed
end('$writeq' / 2):

'$writeRc' / 3:
	allocate(0)
	escape('$writeRc', 3)
	deallocate
	proceed
end('$writeRc' / 3):

'$readc' / 3:
	allocate(0)
	escape('$readc', 3)
	deallocate
	proceed
end('$readc' / 3):

'$readRc' / 4:
	allocate(0)
	escape('$readRc', 4)
	deallocate
	proceed
end('$readRc' / 4):

'$readR1c' / 3:
	allocate(0)
	escape('$readR1c', 3)
	deallocate
	proceed
end('$readR1c' / 3):

'quantify' / 4:
	allocate(0)
	escape('quantify', 4)
	deallocate
	proceed
end('quantify' / 4):

'$substitute' / 3:
	allocate(0)
	escape('$substitute', 3)
	deallocate
	proceed
end('$substitute' / 3):

'$new_dynamic_object_var' / 1:
	allocate(0)
	escape('$new_dynamic_object_var', 1)
	deallocate
	proceed
end('$new_dynamic_object_var' / 1):

'$new_local' / 1:
	allocate(0)
	escape('$new_local', 1)
	deallocate
	proceed
end('$new_local' / 1):

'atom' / 1:
	allocate(0)
	escape('atom', 1)
	deallocate
	proceed
end('atom' / 1):

'integer' / 1:
	allocate(0)
	escape('integer', 1)
	deallocate
	proceed
end('integer' / 1):

'var' / 1:
	allocate(0)
	escape('var', 1)
	deallocate
	proceed
end('var' / 1):

'is_object_var' / 1:
	allocate(0)
	escape('is_object_var', 1)
	deallocate
	proceed
end('is_object_var' / 1):

'$is_local_object_var' / 1:
	allocate(0)
	escape('$is_local_object_var', 1)
	deallocate
	proceed
end('$is_local_object_var' / 1):

'atom_chars' / 2:
	allocate(0)
	escape('atom_chars', 2)
	deallocate
	proceed
end('atom_chars' / 2):

'univ' / 2:
	allocate(0)
	escape('univ', 2)
	deallocate
	proceed
end('univ' / 2):

'functor' / 3:
	allocate(0)
	escape('functor', 3)
	deallocate
	proceed
end('functor' / 3):

'arg' / 3:
	allocate(0)
	escape('arg', 3)
	deallocate
	proceed
end('arg' / 3):

'$equal' / 2:
	allocate(0)
	escape('$equal', 2)
	deallocate
	proceed
end('$equal' / 2):

'$var_less_than' / 2:
	allocate(0)
	escape('$var_less_than', 2)
	deallocate
	proceed
end('$var_less_than' / 2):

'$freeze' / 1:
	allocate(0)
	escape('$freeze', 1)
	deallocate
	proceed
end('$freeze' / 1):

'$thaw' / 1:
	allocate(0)
	escape('$thaw', 1)
	deallocate
	proceed
end('$thaw' / 1):

'$frozen' / 1:
	allocate(0)
	escape('$frozen', 1)
	deallocate
	proceed
end('$frozen' / 1):

'$atoms_to_atom' / 2:
	allocate(0)
	escape('$atoms_to_atom', 2)
	deallocate
	proceed
end('$atoms_to_atom' / 2):

'number_chars' / 2:
	allocate(0)
	escape('number_chars', 2)
	deallocate
	proceed
end('number_chars' / 2):

'get_args' / 1:
	allocate(0)
	escape('get_args', 1)
	deallocate
	proceed
end('get_args' / 1):

'$getwd' / 1:
	allocate(0)
	escape('$getwd', 1)
	deallocate
	proceed
end('$getwd' / 1):

'$exit' / 1:
	allocate(0)
	escape('$exit', 1)
	deallocate
	proceed
end('$exit' / 1):

'statistics' / 1:
	allocate(0)
	escape('statistics', 1)
	deallocate
	proceed
end('statistics' / 1):

'$write_statistics' / 1:
	allocate(0)
	escape('$write_statistics', 1)
	deallocate
	proceed
end('$write_statistics' / 1):

'$label' / 1:
	allocate(0)
	escape('$label', 1)
	deallocate
	proceed
end('$label' / 1):

'$cut' / 1:
	allocate(0)
	escape('$cut', 1)
	deallocate
	proceed
end('$cut' / 1):

'$system' / 3:
	allocate(0)
	escape('$system', 3)
	deallocate
	proceed
end('$system' / 3):

'exec' / 2:
	allocate(0)
	escape('exec', 2)
	deallocate
	proceed
end('exec' / 2):

'$fork' / 0:
	allocate(0)
	escape('$fork', 0)
	deallocate
	proceed
end('$fork' / 0):

'$fork3' / 3:
	allocate(0)
	escape('$fork3', 3)
	deallocate
	proceed
end('$fork3' / 3):

'$setFlag' / 2:
	allocate(0)
	escape('$setFlag', 2)
	deallocate
	proceed
end('$setFlag' / 2):

'$getFlag' / 2:
	allocate(0)
	escape('$getFlag', 2)
	deallocate
	proceed
end('$getFlag' / 2):

'$asserta' / 1:
	allocate(0)
	escape('$asserta', 1)
	deallocate
	proceed
end('$asserta' / 1):

'$assertz' / 1:
	allocate(0)
	escape('$assertz', 1)
	deallocate
	proceed
end('$assertz' / 1):

'$first_clause' / 3:
	allocate(0)
	escape('$first_clause', 3)
	deallocate
	proceed
end('$first_clause' / 3):

'$next_clause' / 2:
	allocate(0)
	escape('$next_clause', 2)
	deallocate
	proceed
end('$next_clause' / 2):

'$last_clause' / 1:
	allocate(0)
	escape('$last_clause', 1)
	deallocate
	proceed
end('$last_clause' / 1):

'$erase' / 1:
	allocate(0)
	escape('$erase', 1)
	deallocate
	proceed
end('$erase' / 1):

'$instance' / 2:
	allocate(0)
	escape('$instance', 2)
	deallocate
	proceed
end('$instance' / 2):

'$instance_no_copy' / 2:
	allocate(0)
	escape('$instance_no_copy', 2)
	deallocate
	proceed
end('$instance_no_copy' / 2):

'$static_predicate' / 3:
	allocate(0)
	escape('$static_predicate', 3)
	deallocate
	proceed
end('$static_predicate' / 3):

'$first_not_free' / 2:
	allocate(0)
	escape('$first_not_free', 2)
	deallocate
	proceed
end('$first_not_free' / 2):

'$get_not_free' / 3:
	allocate(0)
	escape('$get_not_free', 3)
	deallocate
	proceed
end('$get_not_free' / 3):

'$next_not_free' / 2:
	allocate(0)
	escape('$next_not_free', 2)
	deallocate
	proceed
end('$next_not_free' / 2):

'$consult' / 1:
	allocate(0)
	escape('$consult', 1)
	deallocate
	proceed
end('$consult' / 1):

'$times' / 3:
	allocate(0)
	escape('$times', 3)
	deallocate
	proceed
end('$times' / 3):

'$divide' / 3:
	allocate(0)
	escape('$divide', 3)
	deallocate
	proceed
end('$divide' / 3):

'$plus' / 3:
	allocate(0)
	escape('$plus', 3)
	deallocate
	proceed
end('$plus' / 3):

'$minus' / 3:
	allocate(0)
	escape('$minus', 3)
	deallocate
	proceed
end('$minus' / 3):

'$mod' / 3:
	allocate(0)
	escape('$mod', 3)
	deallocate
	proceed
end('$mod' / 3):

'$power' / 3:
	allocate(0)
	escape('$power', 3)
	deallocate
	proceed
end('$power' / 3):

'$bitwise_and' / 3:
	allocate(0)
	escape('$bitwise_and', 3)
	deallocate
	proceed
end('$bitwise_and' / 3):

'$bitwise_or' / 3:
	allocate(0)
	escape('$bitwise_or', 3)
	deallocate
	proceed
end('$bitwise_or' / 3):

'$bitwise_xor' / 3:
	allocate(0)
	escape('$bitwise_xor', 3)
	deallocate
	proceed
end('$bitwise_xor' / 3):

'$shift_left' / 3:
	allocate(0)
	escape('$shift_left', 3)
	deallocate
	proceed
end('$shift_left' / 3):

'$shift_right' / 3:
	allocate(0)
	escape('$shift_right', 3)
	deallocate
	proceed
end('$shift_right' / 3):

'$minus1' / 2:
	allocate(0)
	escape('$minus1', 2)
	deallocate
	proceed
end('$minus1' / 2):

'$complement' / 2:
	allocate(0)
	escape('$complement', 2)
	deallocate
	proceed
end('$complement' / 2):

'$not' / 2:
	allocate(0)
	escape('$not', 2)
	deallocate
	proceed
end('$not' / 2):

'$lt' / 3:
	allocate(0)
	escape('$lt', 3)
	deallocate
	proceed
end('$lt' / 3):

'$leq' / 3:
	allocate(0)
	escape('$leq', 3)
	deallocate
	proceed
end('$leq' / 3):

'$gt' / 3:
	allocate(0)
	escape('$gt', 3)
	deallocate
	proceed
end('$gt' / 3):

'$geq' / 3:
	allocate(0)
	escape('$geq', 3)
	deallocate
	proceed
end('$geq' / 3):

'$less_than' / 2:
	allocate(0)
	escape('$less_than', 2)
	deallocate
	proceed
end('$less_than' / 2):

'$first_delayed_problem' / 1:
	allocate(0)
	escape('$first_delayed_problem', 1)
	deallocate
	proceed
end('$first_delayed_problem' / 1):

'$get_delayed_problem' / 4:
	allocate(0)
	escape('$get_delayed_problem', 4)
	deallocate
	proceed
end('$get_delayed_problem' / 4):

'$next_delayed_problem' / 2:
	allocate(0)
	escape('$next_delayed_problem', 2)
	deallocate
	proceed
end('$next_delayed_problem' / 2):

'$check_delayed_problem' / 1:
	allocate(0)
	escape('$check_delayed_problem', 1)
	deallocate
	proceed
end('$check_delayed_problem' / 1):

'retry_delay_problems' / 0:
	allocate(0)
	escape('retry_delay_problems', 0)
	deallocate
	proceed
end('retry_delay_problems' / 0):

'$new_persistent_meta_var' / 2:
	allocate(0)
	escape('$new_persistent_meta_var', 2)
	deallocate
	proceed
end('$new_persistent_meta_var' / 2):

'$new_persistent_object_var' / 2:
	allocate(0)
	escape('$new_persistent_object_var', 2)
	deallocate
	proceed
end('$new_persistent_object_var' / 2):

'$persistent_meta_var' / 1:
	allocate(0)
	escape('$persistent_meta_var', 1)
	deallocate
	proceed
end('$persistent_meta_var' / 1):

'$persistent_object_var' / 1:
	allocate(0)
	escape('$persistent_object_var', 1)
	deallocate
	proceed
end('$persistent_object_var' / 1):

'$unpersistent_meta_var' / 1:
	allocate(0)
	escape('$unpersistent_meta_var', 1)
	deallocate
	proceed
end('$unpersistent_meta_var' / 1):

'$unpersistent_object_var' / 1:
	allocate(0)
	escape('$unpersistent_object_var', 1)
	deallocate
	proceed
end('$unpersistent_object_var' / 1):

'is_persistent_var' / 1:
	allocate(0)
	escape('is_persistent_var', 1)
	deallocate
	proceed
end('is_persistent_var' / 1):

'is_persistent_object_var' / 1:
	allocate(0)
	escape('is_persistent_object_var', 1)
	deallocate
	proceed
end('is_persistent_object_var' / 1):

'$persistent_name' / 2:
	allocate(0)
	escape('$persistent_name', 2)
	deallocate
	proceed
end('$persistent_name' / 2):

'$copy_to_heap' / 2:
	allocate(0)
	escape('$copy_to_heap', 2)
	deallocate
	proceed
end('$copy_to_heap' / 2):

'$simplify' / 2:
	allocate(0)
	escape('$simplify', 2)
	deallocate
	proceed
end('$simplify' / 2):

'$object_var' / 1:
	allocate(0)
	escape('$object_var', 1)
	deallocate
	proceed
end('$object_var' / 1):

'$object_var_prefix_declared' / 1:
	allocate(0)
	escape('$object_var_prefix_declared', 1)
	deallocate
	proceed
end('$object_var_prefix_declared' / 1):

'$object_var_prefix' / 1:
	allocate(0)
	escape('$object_var_prefix', 1)
	deallocate
	proceed
end('$object_var_prefix' / 1):

'$op_' / 3:
	allocate(0)
	escape('$op_', 3)
	deallocate
	proceed
end('$op_' / 3):

'$first_op' / 1:
	allocate(0)
	escape('$first_op', 1)
	deallocate
	proceed
end('$first_op' / 1):

'$last_op' / 1:
	allocate(0)
	escape('$last_op', 1)
	deallocate
	proceed
end('$last_op' / 1):

'$some_op' / 5:
	allocate(0)
	escape('$some_op', 5)
	deallocate
	proceed
end('$some_op' / 5):

'$next_op' / 2:
	allocate(0)
	escape('$next_op', 2)
	deallocate
	proceed
end('$next_op' / 2):

'$signal' / 2:
	allocate(0)
	escape('$signal', 2)
	deallocate
	proceed
end('$signal' / 2):

'$ipsetc' / 2:
	allocate(0)
	escape('$ipsetc', 2)
	deallocate
	proceed
end('$ipsetc' / 2):

'$iplookupc' / 2:
	allocate(0)
	escape('$iplookupc', 2)
	deallocate
	proceed
end('$iplookupc' / 2):

'$get_unify_delays' / 1:
	allocate(0)
	escape('$get_unify_delays', 1)
	deallocate
	proceed
end('$get_unify_delays' / 1):

'$get_first_unify_delay' / 1:
	allocate(0)
	escape('$get_first_unify_delay', 1)
	deallocate
	proceed
end('$get_first_unify_delay' / 1):

'create_widget' / 3:
	allocate(0)
	escape('create_widget', 3)
	deallocate
	proceed
end('create_widget' / 3):

'initialize_X' / 2:
	allocate(0)
	escape('initialize_X', 2)
	deallocate
	proceed
end('initialize_X' / 2):

'start_X' / 1:
	allocate(0)
	escape('start_X', 1)
	deallocate
	proceed
end('start_X' / 1):

'get_event' / 1:
	allocate(0)
	escape('get_event', 1)
	deallocate
	proceed
end('get_event' / 1):

'destroy_widget' / 1:
	allocate(0)
	escape('destroy_widget', 1)
	deallocate
	proceed
end('destroy_widget' / 1):

'set_widget_resource' / 3:
	allocate(0)
	escape('set_widget_resource', 3)
	deallocate
	proceed
end('set_widget_resource' / 3):

'$string_read' / 1:
	allocate(0)
	escape('$string_read', 1)
	deallocate
	proceed
end('$string_read' / 1):

'$no_string_read' / 0:
	allocate(0)
	escape('$no_string_read', 0)
	deallocate
	proceed
end('$no_string_read' / 0):

'$write_to_text_widget' / 1:
	allocate(0)
	escape('$write_to_text_widget', 1)
	deallocate
	proceed
end('$write_to_text_widget' / 1):

'$close_write_to_text_widget' / 0:
	allocate(0)
	escape('$close_write_to_text_widget', 0)
	deallocate
	proceed
end('$close_write_to_text_widget' / 0):

'text_widget_string' / 2:
	allocate(0)
	escape('text_widget_string', 2)
	deallocate
	proceed
end('text_widget_string' / 2):

'clear_text_widget' / 3:
	allocate(0)
	escape('clear_text_widget', 3)
	deallocate
	proceed
end('clear_text_widget' / 3):

'$new_term_write' / 0:
	allocate(0)
	escape('$new_term_write', 0)
	deallocate
	proceed
end('$new_term_write' / 0):

'$write_done' / 0:
	allocate(0)
	escape('$write_done', 0)
	deallocate
	proceed
end('$write_done' / 0):

'error_widget' / 1:
	allocate(0)
	escape('error_widget', 1)
	deallocate
	proceed
end('error_widget' / 1):

'selected_path' / 1:
	allocate(0)
	escape('selected_path', 1)
	deallocate
	proceed
end('selected_path' / 1):

'selected_widget' / 1:
	allocate(0)
	escape('selected_widget', 1)
	deallocate
	proceed
end('selected_widget' / 1):

'$widget_read' / 1:
	allocate(0)
	escape('$widget_read', 1)
	deallocate
	proceed
end('$widget_read' / 1):

'popup_widget' / 1:
	allocate(0)
	escape('popup_widget', 1)
	deallocate
	proceed
end('popup_widget' / 1):

'popdown_widget' / 1:
	allocate(0)
	escape('popdown_widget', 1)
	deallocate
	proceed
end('popdown_widget' / 1):

'$write_to_term_widget' / 1:
	allocate(0)
	escape('$write_to_term_widget', 1)
	deallocate
	proceed
end('$write_to_term_widget' / 1):

'path_to_string' / 4:
	allocate(0)
	escape('path_to_string', 4)
	deallocate
	proceed
end('path_to_string' / 4):

'text_widget_tabs' / 2:
	allocate(0)
	escape('text_widget_tabs', 2)
	deallocate
	proceed
end('text_widget_tabs' / 2):

'install_widget_accelerators' / 2:
	allocate(0)
	escape('install_widget_accelerators', 2)
	deallocate
	proceed
end('install_widget_accelerators' / 2):

'set_keyboard_focus_widget' / 2:
	allocate(0)
	escape('set_keyboard_focus_widget', 2)
	deallocate
	proceed
end('set_keyboard_focus_widget' / 2):

'$string_read_position' / 1:
	allocate(0)
	escape('$string_read_position', 1)
	deallocate
	proceed
end('$string_read_position' / 1):

'widget_write_position' / 2:
	allocate(0)
	escape('widget_write_position', 2)
	deallocate
	proceed
end('widget_write_position' / 2):

'save_text_widget' / 2:
	allocate(0)
	escape('save_text_widget', 2)
	deallocate
	proceed
end('save_text_widget' / 2):

'$add_spy' / 2:
	allocate(0)
	escape('$add_spy', 2)
	deallocate
	proceed
end('$add_spy' / 2):

'$list_spied_predicates' / 0:
	allocate(0)
	escape('$list_spied_predicates', 0)
	deallocate
	proceed
end('$list_spied_predicates' / 0):

'$delete_spy' / 2:
	allocate(0)
	escape('$delete_spy', 2)
	deallocate
	proceed
end('$delete_spy' / 2):

'$delete_all_spied_predicates' / 0:
	allocate(0)
	escape('$delete_all_spied_predicates', 0)
	deallocate
	proceed
end('$delete_all_spied_predicates' / 0):

'$trace' / 0:
	allocate(0)
	escape('$trace', 0)
	deallocate
	proceed
end('$trace' / 0):

'$append' / 3:
	allocate(0)
	escape('$append', 3)
	deallocate
	proceed
end('$append' / 3):

